#include "hw_impl_zybo.h"

struct UARTDriver create_zybo_uart() {
  struct UARTDriver uart;
  uart.state = NULL;
  uart.reset = zybo_uart_reset;
  uart.write = zybo_uart_write;
  uart.read = zybo_uart_read;
  return uart;
}

struct MotorDriver create_zybo_motors() {
  struct MotorDriver motors;
  motors.state = NULL;
  motors.reset = zybo_motor_reset;
  motors.write = zybo_motor_write;
  return motors;
}

struct RCReceiverDriver create_zybo_rc_receiver() {
  struct RCReceiverDriver rc_receiver;
  rc_receiver.state = NULL;
  rc_receiver.reset = zybo_rc_receiver_reset;
  rc_receiver.read = zybo_rc_receiver_read;
  return rc_receiver;
}

struct I2CDriver create_zybo_i2c() {
  struct I2CDriver i2c;
  i2c.state = NULL;
  i2c.reset = zybo_i2c_reset;
  i2c.write = zybo_i2c_write;
  i2c.read = zybo_i2c_read;
  return i2c;
}

struct TimerDriver create_zybo_global_timer() {
  struct TimerDriver global_timer;
  global_timer.state = NULL;
  global_timer.reset = zybo_global_timer_reset;
  global_timer.restart = zybo_global_timer_restart;
  global_timer.read = zybo_global_timer_read;
  return global_timer;
}

struct TimerDriver create_zybo_axi_timer() {
  struct TimerDriver axi_timer;
  axi_timer.state = NULL;
  axi_timer.reset = zybo_axi_timer_reset;
  axi_timer.restart = zybo_axi_timer_restart;
  axi_timer.read = zybo_axi_timer_read;
  return axi_timer;
}

struct LEDDriver create_zybo_mio7_led() {
  struct LEDDriver mio7_led;
  mio7_led.state = NULL;
  mio7_led.reset = zybo_mio7_led_reset;
  mio7_led.turn_on = zybo_mio7_led_turn_on;
  mio7_led.turn_off = zybo_mio7_led_turn_off;
  return mio7_led;
}

struct SystemDriver create_zybo_system() {
  struct SystemDriver sys;
  sys.state = NULL;
  sys.reset = zybo_system_reset;
  sys.sleep = zybo_system_sleep;
  return sys;
}
